-- ---------------------
-- KAPITEL 7 (Oracle 21)
-- ---------------------

-- Filter:
SELECT count(*)
FROM GeoGemeinden g INNER JOIN Ortsnetze n
ON SDO_FILTER (n.gebiet, g.geom) = 'TRUE';

-- Exakter Test:
SELECT count(*)
FROM GeoGemeinden g INNER JOIN Ortsnetze n
ON SDO_RELATE (n.gebiet, g.geom, 'mask=CONTAINS') = 'TRUE';

EXPLAIN PLAN FOR SELECT count(*)
FROM GeoGemeinden g INNER JOIN Ortsnetze n
ON SDO_FILTER (n.gebiet, g.geom) = 'TRUE';

SELECT SDO_JOIN('GeoGemeinden','geom','Ortsnetze','gebiet','mask=INSIDE')
FROM Dual;

-- Ausgabe der RowID-Paare:
SELECT res.rowid1, res.rowid2
FROM TABLE(SDO_JOIN('GeoGemeinden','geom', 'Ortsnetze','gebiet',
                    'mask=INSIDE')) res;

-- Ausgaben der Namen:
SELECT g.name AS Gemeindezentrum, n.name AS Ortsnetz
FROM TABLE(SDO_JOIN('GeoGemeinden','geom','Ortsnetze','gebiet',
                    'mask=INSIDE')) res,  Ortsnetze n,  GeoGemeinden g
WHERE g.rowid = res.rowid1 AND n.rowid = res.rowid2;

SELECT g.name AS Gemeindezentrum, n.name AS Ortsnetz
FROM TABLE(SDO_JOIN('GeoGemeinden','geom', 'Ortsnetze','gebiet',
                    'distance=10 unit=KM')) res, Ortsnetze n, GeoGemeinden g
WHERE g.rowid = res.rowid1 AND n.rowid = res.rowid2;


-- 7.2.2.2 NNQ in Oracle Spatial

SELECT name
FROM Ortsnetze
WHERE SDO_NN (gebiet, SDO_GEOMETRY('POINT(8.816336 52.914548)',4326),
             'sdo_num_res=12') = 'TRUE';

SELECT n.name
FROM Ortsnetze n INNER JOIN MMGemeinden g
ON SDO_NN (n.gebiet,g.geom,'sdo_num_res=12') = 'TRUE'
WHERE code = 'DE03251041';

SELECT name, SDO_NN_DISTANCE(1)
FROM Ortsnetze
WHERE SDO_NN (gebiet, SDO_GEOMETRY('POINT(8.816336 52.914548)',4326),
             'sdo_num_res=12, unit=km',1) = 'TRUE'
ORDER BY SDO_NN_DISTANCE(1);

SELECT name
FROM Ortsnetze
WHERE SDO_NN(gebiet,SDO_GEOMETRY('POINT(8.816336 52.914548)',4326))='TRUE';

SELECT name, SDO_NN_DISTANCE(1)
FROM Ortsnetze
WHERE SDO_NN (gebiet, SDO_GEOMETRY('POINT(8.816336 52.914548)',4326),
             'sdo_num_res=5, unit=km',1) = 'TRUE' AND name <> 'Syke'

SELECT ROWNUM, name, SDO_NN_DISTANCE(1)
FROM Ortsnetze
WHERE SDO_NN (gebiet, SDO_GEOMETRY('POINT(8.816336 52.914548)',4326),
             'sdo_batch_size=10, unit=km',1) = 'TRUE' AND 
      name <> 'Syke' AND ROWNUM <= 5
ORDER BY SDO_NN_DISTANCE(1);


